zoukankan      html  css  js  c++  java
  • POJ 2376 Cleaning shifts 贪心 基础题

                      Cleaning Shifts
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 13042   Accepted: 3373

    Description

    Farmer John is assigning some of his N (1 <= N <= 25,000) cows to do some cleaning chores around the barn. He always wants to have one cow working on cleaning things up and has divided the day into T shifts (1 <= T <= 1,000,000), the first being shift 1 and the last being shift T. 

    Each cow is only available at some interval of times during the day for work on cleaning. Any cow that is selected for cleaning duty will work for the entirety of her interval. 

    Your job is to help Farmer John assign some cows to shifts so that (i) every shift has at least one cow assigned to it, and (ii) as few cows as possible are involved in cleaning. If it is not possible to assign a cow to each shift, print -1.

    Input

    * Line 1: Two space-separated integers: N and T 

    * Lines 2..N+1: Each line contains the start and end times of the interval during which a cow can work. A cow starts work at the start time and finishes after the end time.

    Output

    * Line 1: The minimum number of cows Farmer John needs to hire or -1 if it is not possible to assign a cow to each shift.

    Sample Input

    3 10
    1 7
    3 6
    6 10

    Sample Output

    2

    Hint

    This problem has huge input data,use scanf() instead of cin to read data to avoid time limit exceed. 

    INPUT DETAILS: 

    There are 3 cows and 10 shifts. Cow #1 can work shifts 1..7, cow #2 can work shifts 3..6, and cow #3 can work shifts 6..10. 

    OUTPUT DETAILS: 

    By selecting cows #1 and #3, all shifts are covered. There is no way to cover all the shifts using fewer than 2 cows.

    Source

     
     
     
     
     
     
    题意:给出N条线段,和一个区间T,要求从这N条线段中选出最小的数量的线段,使得可以覆盖区间T
           无法做到输出-1
     
    把线段排序后,直接遍历一遍线段就好啦。
     
    贪心:
    cnt表示目前还没有被覆盖的区间的最左边。
    则cnt-1就是已经被覆盖的区间的最右边
     
    遍历的时候,我们要从线段中选择满足left<=cnt&&right>=cnt中right最远的一条线段。
     
     
     
     1 #include<cstdio>
     2 #include<cstring>
     3 #include<algorithm>
     4 
     5 using namespace std;
     6 
     7 const int maxn=25000+3;
     8 const int inf=0x3f3f3f3f;
     9 
    10 struct Edge
    11 {
    12     int l,r;
    13 }edge[maxn];
    14 
    15 bool cmp(Edge a,Edge b)
    16 {
    17     if(a.l==b.l)
    18         return a.r<b.r;
    19     else
    20         return a.l<b.l;
    21 }
    22 
    23 int solve(int N,int T)
    24 {
    25     sort(edge,edge+N,cmp);
    26 
    27     int ret=0;
    28     int cnt=1;
    29     int i=0;
    30     while(true)
    31     {
    32         int maxl=cnt-1;
    33 
    34         for(;i<N;i++)
    35         {
    36             if(edge[i].l<=cnt&&edge[i].r>=cnt)
    37                 maxl=max(maxl,edge[i].r);
    38             if(edge[i].l>cnt)
    39                 break;
    40         }
    41 
    42         if(maxl<cnt)
    43             return -1;
    44         ret++;
    45         cnt=maxl+1;
    46         if(cnt>T)
    47             return ret;
    48     }
    49 }
    50 
    51 int main()
    52 {
    53     int N,T;
    54     while(~scanf("%d%d",&N,&T))
    55     {
    56         for(int i=0;i<N;i++)
    57         {
    58             scanf("%d%d",&edge[i].l,&edge[i].r);
    59         }
    60 
    61         printf("%d
    ",solve(N,T));
    62     }
    63     return 0;
    64 }
    View Code
     
        
     
     
     
  • 相关阅读:
    codeforce A. 2Char(水题,暴力)
    hdu 4704 Sum(组合,费马小定理,快速幂)
    light oj 1100
    hdu 4503 湫湫系列故事——植树节(组合概率)
    Codeforces Round #327 (Div. 1), problem: (A) Median Smoothing
    hdu-3833 YY's new problem(数组标记)
    hdu 4549 M斐波那契数列(快速幂 矩阵快速幂 费马小定理)
    hdu 1431 素数回文(暴力打表,埃托色尼筛法)
    hdu 1430 (BFS 康托展开 或 map )
    hdu 1024 max sum plus plus
  • 原文地址:https://www.cnblogs.com/-maybe/p/4598899.html
Copyright © 2011-2022 走看看